<template>
  <crud-data-table-delete
    v-model="dialog"
    :item-being-deleted="itemBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  >
    <template v-slot:itemBeingDelete>
      {{ $t('itemBeingDelete', { company: itemBeingDeleted.companyNickname }) }}
      <ul>
        <li>
          {{ $t('purchaseDate', {
            purchaseDate: $options.filters.symbolWhenEmpty(
              $options.filters.formatDate(
                itemBeingDeleted.purchaseDate
              )
            ) })
          }}
        </li>
        <li>
          {{ $t('category', { category: $options.filters.symbolWhenEmpty(itemBeingDeleted.category) }) }}
        </li>
        <li>
          {{ $t('paymentStatus', { paymentStatus: $options.filters.symbolWhenEmpty(itemBeingDeleted.paymentStatus) }) }}
        </li>
        <li>
          {{ $t('paymentMethod', { paymentMethod: $options.filters.symbolWhenEmpty(itemBeingDeleted.paymentMethod) }) }}
        </li>
        <li>
          {{ $t('amountsSum', {
            amountsSum: $options.filters.symbolWhenEmpty(
              $options.filters.formatCurrency(
                itemBeingDeleted.amountsSum
              )
            ) })
          }}
        </li>
      </ul>
    </template>
    <template v-slot:whatWillHappenWhenDeleted>
      {{ $t('whatWillHappenWhenDeleted') }}
    </template>
  </crud-data-table-delete>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'
  import UtilsMixin from '@/mixins/utils'

  export default {
    name: 'DeleteExpenseDialog',
    mixins: [DatesMixin, MoneyMixin, UtilsMixin],
    data () {
      return {
        dialog: false,
        isLoading: false,
        itemBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeleteExpense', this.onDeleteExpense)
    },
    methods: {
      onDeleteExpense (expense) {
        this.itemBeingDeleted = expense
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('expenses/deleteExpense', {
          ID: this.itemBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          deleteSuccess: 'Despesa excluída com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir a despesa. Por favor, tente novamente.',
          whatWillHappenWhenDeleted: 'Todos os valores desta despesa deixarão de ser considerados nos cálculos.',
          itemBeingDelete: 'Você está excluíndo uma despesa da empresa: {company}.',
          purchaseDate: 'Data da compra: {purchaseDate}',
          category: 'Categoria: {category}',
          paymentStatus: 'Status: {paymentStatus}',
          paymentMethod: 'Via de pagamento: {paymentMethod}',
          amountsSum: 'R$ Total: {amountsSum}',
        },
        'en-US': {
          deleteSuccess: 'Expense successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the expense. Please try again.',
          whatWillHappenWhenDeleted: 'All values of this expense will no longer be considered in the calculations.',
          itemBeingDelete: 'You are deleting an expense from the company: {company}.',
          purchaseDate: 'Purchase date: {purchaseDate}',
          category: 'Category: {category}',
          paymentStatus: 'Payment status: {paymentStatus}',
          paymentMethod: 'Payment method: {paymentMethod}',
          amountsSum: '$ Total: {amountsSum}',
        },
      },
    },
  }
</script>
